Index: /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PI.xcodeproj/brunomansoux.pbxuser	(revision 3747)
@@ -1828,14 +1591,14 @@
 	6DFD5AD406774017009E5976 /* PIApplQuartz.h */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {1062, 728}}";
-			sepNavSelRange = "{318, 54}";
-			sepNavVisRect = "{{0, 0}, {1062, 287}}";
+			sepNavIntBoundsRect = "{{0, 0}, {727, 859}}";
+			sepNavSelRange = "{579, 0}";
+			sepNavVisRect = "{{0, 0}, {727, 859}}";
 		};
 	};
 	6DFD5AD506774017009E5976 /* PIApplQuartz.cpp */ = {
 		uiCtxt = {
-			sepNavIntBoundsRect = "{{0, 0}, {783, 1358}}";
-			sepNavSelRange = "{153, 0}";
-			sepNavVisRect = "{{0, 0}, {783, 410}}";
+			sepNavIntBoundsRect = "{{0, 0}, {813, 1414}}";
+			sepNavSelRange = "{757, 0}";
+			sepNavVisRect = "{{0, 336}, {813, 385}}";
 		};
 	};
Index: /trunk/SophyaPI/PI/Quartz/PIApplQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIApplQuartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIApplQuartz.cpp	(revision 3747)
@@ -12,4 +12,6 @@
 static OSErr QuitAppleEventHandler(const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon);
 
+static PIApplication* cur_piapp = NULL;
+PIApplication* PIApplicationGetApp() { return cur_piapp; }
 
 PIApplicationQuartz::PIApplicationQuartz()
@@ -25,4 +27,5 @@
         
     menubar = new PIMenubar(this, "DefMenubar");
+	cur_piapp = this;
 }
 
@@ -43,4 +46,5 @@
   mainWindow = new PIWindow(this,(const char*)"Main Window",PIWK_normal,width,height,50,50);
   mainWindow->Refresh();
+  cur_piapp = this;
 }
 
Index: /trunk/SophyaPI/PI/Quartz/PIApplQuartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIApplQuartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIApplQuartz.h	(revision 3747)
@@ -35,10 +35,10 @@
     virtual void	ScreenResolution(int& resolx, int& resoly);
 	
-	virtual void              RedirectOutStream(PIConsole* cons, unsigned char va= PIVA_Def)  {};
-	virtual void              RedirectErrStream(PIConsole* cons, unsigned char va= PIVA_Red) {};
+	virtual void	RedirectOutStream(PIConsole* cons, unsigned char va= PIVA_Def)  {};
+	virtual void    RedirectErrStream(PIConsole* cons, unsigned char va= PIVA_Red) {};
 
-	virtual void              RedirectOutStream(PIConsole* cons, string const & flnm, bool fgcpos=false, 
+	virtual void    RedirectOutStream(PIConsole* cons, string const & flnm, bool fgcpos=false, 
 						    unsigned char va= PIVA_Def)  {};
-	virtual void              RedirectErrStream(PIConsole* cons, string const & flnm, bool fgcpos=false, 
+	virtual void    RedirectErrStream(PIConsole* cons, string const & flnm, bool fgcpos=false, 
 						    unsigned char va= PIVA_Def)  {};
 
@@ -49,3 +49,6 @@
 typedef PIApplicationQuartz PIApplication;
 
+//  Pour recuperer un objet PIApplication 
+PIApplication* PIApplicationGetApp();
+
 #endif
Index: /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp	(revision 3747)
@@ -4,5 +4,4 @@
  *
  *  Created by Bruno MANSOUX on Tue May 04 2004.
- *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
  *
  */
@@ -31,13 +30,12 @@
 
 /* --Methode-- */
-ControlHandle PIContainerQuartz::GetControlHandle()
+HIViewRef PIContainerQuartz::GetHIViewRef()
 {
-    return contH;
+    return viewH;
 }
 
 /* --Methode-- */
-WindowPtr PIContainerQuartz::GetWindowPtr()
+WindowRef PIContainerQuartz::GetWindowRef()
 {
-    return wPtr;
+    return HIViewGetWindow(viewH);
 }
-
Index: /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.h	(revision 3747)
@@ -22,8 +22,8 @@
     virtual	~PIContainerQuartz();
 
-    virtual void        Process(PIMessage msg, PIMsgHandler* sender, void* data=NULL);
-
-    virtual ControlHandle GetControlHandle();
-    virtual WindowPtr GetWindowPtr();
+    virtual void Process(PIMessage msg, PIMsgHandler* sender, void* data=NULL);
+	
+    virtual HIViewRef GetHIViewRef();
+	virtual WindowRef GetWindowRef();
 };
 
Index: /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.cpp	(revision 3747)
@@ -28,4 +28,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuBarQuartz::AppendMenu(PIMenu *pdm)
 {
@@ -35,4 +36,13 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
+void PIMenuBarQuartz::AppendPopupMenu(PIMenu *pdm)
+{
+	InsertMenu (pdm->GetMenuRef(),kInsertHierarchicalMenu);
+	vPIMenu.push_back(pdm);
+	return;
+}
+
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuBarQuartz::RemoveMenu(PIMenu *pdm)
 {
@@ -47,8 +57,10 @@
             }
         }
+		
     DeleteMenu (pdm->GetMenuID());
     return;
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuBarQuartz::SetSensitivity(PIMenu *pdm, bool sens)
 {
@@ -57,4 +69,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuBarQuartz::IsSensitive(PIMenu *pdm)
 {
@@ -63,22 +76,37 @@
 }
 
-PIMessage PIMenuBarQuartz::GetMsg(MenuRef menuRef, int commandID)
+/* ----------------------------- Methode ------------------------------- */
+PIMessage PIMenuBarQuartz::GetMsg(HICommand commandStruct)
 {
+	MenuRef menuRef = commandStruct.menu.menuRef;
+	UInt32 commandID = commandStruct.commandID;
+	UInt16 itemIndex = commandStruct.menu.menuItemIndex;
+	
     vector<PIMenu*>::iterator it;
     for(it = vPIMenu.begin(); it != vPIMenu.end(); it++)
         {
-            if ((*it)->GetMenuRef() == menuRef)
+           if ((*it)->GetMenuRef() == menuRef)
             {
+				if ((*it)->MType() == k_PopupMenu)
+				{
+					PIWdg* piWdg;
+					ControlRef contH;
+					piWdg = (*it)->GetParent();
+					contH = piWdg->GetHIViewRef();
+//					printf("PopValue : %d \n", GetControl32BitValue(contH));
+					SetControl32BitValue(contH, itemIndex);
+				}
                 return (*it)->GetMsgItem(commandID);
             }
         }
 	return 0;
-} 
+}
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuBarQuartz::Dispatch(HICommand commandStruct, void* userData)
 {
 	PIMessage msg;
 	
-	msg = GetMsg(commandStruct.menu.menuRef,commandStruct.commandID);
+	msg = GetMsg(commandStruct);
 	Process(BuildMsg(msg,PIMsg_Click), piApp, userData);
 		
@@ -120,5 +148,4 @@
 		result = noErr;
     }
-
     return (result);
 }
Index: /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIMenuBarQuartz.h	(revision 3747)
@@ -20,8 +20,9 @@
     ~PIMenuBarQuartz();
     virtual void AppendMenu(PIMenu *pdm);
+	virtual void AppendPopupMenu(PIMenu *pdm);
     virtual void RemoveMenu(PIMenu *pdm);
     virtual void SetSensitivity(PIMenu *pdm, bool sens=true);
     virtual bool IsSensitive(PIMenu *pdm);
-	PIMessage GetMsg(MenuRef menuRef, int commandID);
+	PIMessage GetMsg(HICommand commandStruct);
 	void Dispatch(HICommand commandStruct, void* userData);
 
Index: /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp	(revision 3747)
@@ -10,5 +10,5 @@
 #include "PIMenuQuartz.h"
 
-
+/* ----------------------------- Methode ------------------------------- */
 PIMenuQuartz::PIMenuQuartz(PIWdg* par, const char* nom, PIMenuType pdpu)
 :PIMenuGen(par, nom, pdpu)
@@ -17,17 +17,21 @@
     Str255 menuTitle;
 
+    mNItem = 0;  mNItemMax = 0;     
+    mMenuID = mMenuIdentificateur++;
+
+//    Beware with using this attribute, no place for check mark!
+//    CreateNewMenu (mMenuID, kMenuAttrExcludesMarkColumn, &mMenu);
+
 //  Popupmenu are associated with ButtonControl
     if (pdpu == k_PopupMenu)
-        {        
-        }
-    
-    mNItem = 0;  mNItemMax = 0;     
-    mMenuID = mMenuIdentificateur++;
-
-//    Beware with using this attribute, no place for check mark!
-//    CreateNewMenu (mMenuID, kMenuAttrExcludesMarkColumn, &mMenu);
-
-    CreateNewMenu (mMenuID,kMenuAttrAutoDisable, &mMenu);
-    
+	{
+		CreateNewMenu (mMenuID, kMenuAttrHidden, &mMenu);
+	}
+    else
+	{
+		CreateNewMenu (mMenuID, kMenuAttrAutoDisable, &mMenu);
+    }
+	
+	parent = par;
     CopyCStringToPascal (nom, menuTitle);
     SetMenuTitle (mMenu, menuTitle);
@@ -35,4 +39,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 PIMenuQuartz::~PIMenuQuartz()
 {
@@ -40,4 +45,5 @@
 }
 				   
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendItem(const char* nom, PIMessage msg, char* sc)
 {
@@ -76,4 +82,5 @@
 }
 				   
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendCheckItem(const char* nom, PIMessage msg, char* sc)
 {
@@ -85,4 +92,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendPDMenu(PIMenuGen *pdm, char* sc)
 {
@@ -91,5 +99,5 @@
 }
 
-
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendCascadeMenu(PIMenuQuartz* cascadeMenu, PIMessage msg)
 {
@@ -103,4 +111,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendSeparator()
 {
@@ -112,4 +121,5 @@
 
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItem(const char *nom)
 {
@@ -123,4 +133,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItemMsg(PIMessage msg)
 {
@@ -128,4 +139,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItemNum(int n)
 {
@@ -135,4 +147,5 @@
 
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivity(const char *nom, bool sens)
 {
@@ -143,4 +156,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivityMsg(PIMessage msg, bool sens) 
 {
@@ -151,4 +165,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivityNum(int n, bool sens)
 {
@@ -160,4 +175,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitive(const char *nom)
 {
@@ -167,4 +183,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitiveMsg(PIMessage msg)
 {
@@ -174,4 +191,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitiveNum(int n)
 {
@@ -179,4 +197,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetState(const char *nom, bool st)
 {
@@ -187,4 +206,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetStateMsg(PIMessage msg, bool st)
 {
@@ -195,4 +215,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetStateNum(int n, bool st)
 {
@@ -200,4 +221,5 @@
 }
  
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetState(const char *nom)
 {
@@ -208,4 +230,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetStateMsg(PIMessage msg)
 {
@@ -216,4 +239,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetStateNum(int n)
 {
@@ -221,4 +245,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::Show()
 {
@@ -227,4 +252,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::Show(PIWdg *w, int px, int py)
 {
@@ -233,4 +259,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 PIMessage PIMenuQuartz::GetMsgItem(int itemID)
 {
@@ -246,4 +273,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 int PIMenuQuartz::GetNumItem(const char* nom)
 {
@@ -269,4 +297,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 int PIMenuQuartz::GetNumItemMsg(PIMessage msg)
 {
@@ -280,4 +309,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 char*  PIMenuQuartz::ItemName(int n)
 {
@@ -287,4 +317,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 MenuRef PIMenuQuartz::GetMenuRef()
 {
@@ -292,6 +323,15 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 MenuID PIMenuQuartz::GetMenuID()
 {
     return (mMenuID);
 }
+
+/* ----------------------------- Methode ------------------------------- */
+PIWdg* PIMenuQuartz::GetParent()
+{
+    return (parent);
+}
+
+
Index: /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIMenuQuartz.h	(revision 3747)
@@ -65,6 +65,8 @@
   MenuRef	GetMenuRef ();
   MenuID	GetMenuID ();
+  PIWdg*	GetParent ();
     
   protected:
+	PIWdg* parent;
     MenuRef mMenu;
     int     mMenuID;
Index: /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp	(revision 3747)
@@ -16,21 +16,22 @@
     WindowAttributes windowAttributes;
     
-/*
-	wParent = ((PIContainer *)par)->GetWindowPtr();
+	/*
+	wParent = ((PIContainer *)par)->GetWindowRef();
 	SetPortWindowPort(wParent);
 	*/
 	
     SetRect(&wdgRect,px,py,px+sx,py+sy);
-    // windowAttributes = kWindowStandardDocumentAttributes | kWindowCompositingAttribute ;
-	windowAttributes = kWindowStandardDocumentAttributes;
+	windowAttributes = kWindowStandardDocumentAttributes | kWindowCompositingAttribute ;
 	
-    err = CreateNewWindow (kDocumentWindowClass,windowAttributes,&wdgRect,&wPtr);
+	err = CreateNewWindow (kDocumentWindowClass,windowAttributes,&wdgRect,&wRef);
+
     if (err)
         printf ("PIWindowQuartz Create Err = %d \n",err);
     fflush (stdout);
     
-    err = SetWindowTitleWithCFString (wPtr,title);
-    
-    InstallStandardEventHandler(GetWindowEventTarget(wPtr)); /* installs the default */    
+    err = SetWindowTitleWithCFString (wRef, title);
+
+	viewH = HIViewGetRoot(wRef);
+    InstallStandardEventHandler(GetWindowEventTarget(wRef)); /* installs the default */
 }
 
@@ -42,5 +43,5 @@
 void PIWindowQuartz::SetSize(int sx, int sy)
 {
-    SizeWindow (wPtr, sx, sy, true);
+    SizeWindow (wRef, sx, sy, true);
     return;
 }
@@ -48,5 +49,5 @@
 void PIWindowQuartz::SetPos(int px, int py)
 {
-    MoveWindow (wPtr, px, py, false);
+    MoveWindow (wRef, px, py, false);
     return;
 }
@@ -59,5 +60,5 @@
 void PIWindowQuartz::UnManage()
 {
-	HideWindow(wPtr);
+	HideWindow(wRef);
     return;
 }
@@ -70,5 +71,5 @@
 bool PIWindowQuartz::IsVisible()
 {
-    return (IsWindowVisible(wPtr));
+    return (IsWindowVisible(wRef));
 }
 
@@ -76,11 +77,11 @@
 void PIWindowQuartz::Refresh()
 {
-    SetPortWindowPort(wPtr);
-    BeginUpdate(wPtr);
-	EraseRect(GetWindowPortBounds(wPtr, &wdgRect));
-    DrawControls(wPtr);
-    DrawGrowIcon(wPtr);
-    EndUpdate(wPtr);
-    ShowWindow (wPtr);
+    SetPortWindowPort(wRef);
+    BeginUpdate(wRef);
+	EraseRect(GetWindowPortBounds(wRef, &wdgRect));
+    DrawControls(wRef);
+    DrawGrowIcon(wRef);
+    EndUpdate(wRef);
+    ShowWindow (wRef);
     return ;
 }
@@ -94,5 +95,5 @@
 void PIWindowQuartz::SetSensitive()
 {
-    ActivateWindow (wPtr, true);
+    ActivateWindow (wRef, true);
     return;
 }
@@ -100,5 +101,5 @@
 void PIWindowQuartz::SetUnSensitive()
 {
-    ActivateWindow (wPtr, false);
+    ActivateWindow (wRef, false);
     return;
 }
@@ -106,5 +107,5 @@
 bool PIWindowQuartz::IfSensitive()
 {
-    return (IsWindowActive(wPtr));
+    return (IsWindowActive(wRef));
 }
 
@@ -130,5 +131,4 @@
 }
 
-
 // En public, pour permettre l'acces depuis call-back Xt
 void PIWindowQuartz::CallDrawHandlers(int x0, int y0, int dx, int dy)
Index: /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.h	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.h	(revision 3747)
@@ -53,5 +53,7 @@
   virtual void		 CallEventHandlers(unsigned long evt, int px, int py,
                                            int k, int km, unsigned long tm);
-
+protected:
+    WindowRef	wRef;
+	WindowRef	wParent;
 };
 
Index: /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp	(revision 3747)
@@ -1,9 +1,6 @@
 /*
     QuartzAppTest.cpp
-    
-    BMX 14/06/04 
-    
-    Test Program for PI4Mac validation
-    
+    BMX 14/06/06
+    Test Program for PI4Mac validation    
 */
 
@@ -11,57 +8,172 @@
 #include <PIMenuBarQuartz.h>
 #include <PIWindowQuartz.h>
-#include <pistdwdgmosx.h>
+#include <pioptmenuquartz.h>
+#include <pistdwdgquartz.h>
+#include <pigraphquartz.h>
+#include <iostream>
+
+#define NBCOTE 7
+
+void FillDatas();
+
+PIGraphicWin* pig;
+PIGrCoord* tabx;
+PIGrCoord* taby;
+
+/* ============================== */
+class QuartzApp : public PIApplication
+{
+public:
+	QuartzApp();
+	~QuartzApp();
+	virtual void Process (PIMessage msg, PIMsgHandler* sender, void * data = NULL);
+};
+
+/* ============================== */
+QuartzApp::QuartzApp()
+: PIApplication()
+{
+}
+
+/* ============================== */
+QuartzApp::~QuartzApp()
+{
+}
+
+/* ============================== */
+
+void QuartzApp::Process (PIMessage msg, PIMsgHandler* sender, void * data)
+{
+  switch(UserMsg(msg))    
+	{	
+		case 777:
+		std::cout << " Erase " << std::endl;
+		pig->Erase(280,60,100,50);
+		break;
+
+		case 2001:
+		std::cout << " Circle " << std::endl;
+		pig->DrawCircle(360,100,30);
+		break;
+		
+		case 2002:
+		std::cout << " Polygone " << std::endl;
+		pig->DrawPolygon(tabx, taby, NBCOTE, 0);
+		break;
+		
+		case 3001:
+		std::cout << " Pop 1 " << std::endl;
+		break;
+	
+		case 3002:
+		std::cout << " Pop 2 " << std::endl;
+		break;
+		
+		default:
+		std::cout << " msg : "<< UserMsg(msg) << std::endl;
+		break;
+	}
+
+	return;
+}
 
 
+/* ============================== */
 int main(int argc, char *argv[])
 {
-    PIApplication* mainApp;
+    QuartzApp* mainApp;
     PIMenu* firstMenu;
-    PIMenu* underMenu;    
+    PIMenu* underMenu;
+	PIMenu* popMenu;
+	PIMenu* figuresMenu;
+	PIOptMenu* optMenu;  
     PIMenubar* mBar;
-    PIWindow* windowFirst;				
-    PIContainer* piCont;
-    PIWindowGen* wGen;
-    PIContainer* piContQ; 
-    PIWdg* piWdg;
+    PIWindow* windowFirst;	
 	PILabel *piLabel;
     PIButton* piButton;
     vector<int> points;
 
-    /* Creation of general objects */
+    /* Creation of general graphical objects */
 
-    mainApp = new PIApplication();
-    piCont = mainApp->MainWin();
+    mainApp = new QuartzApp();
 
-    firstMenu = new PIMenu((PIWdg *)mainApp, (const char *)"First Menu");
-    firstMenu->AppendItem("One from first", 1000);
+    firstMenu = new PIMenu((PIWdg *)mainApp, (const char *)"File Menu");
+    firstMenu->AppendItem("One from file", 1000);
     firstMenu->AppendSeparator();
-    firstMenu->AppendItem("Two from first", 1001);
-    firstMenu->AppendCheckItem("Three from first", 1002);
+    firstMenu->AppendItem("Two from file", 1001);
+    firstMenu->AppendCheckItem("Check from file", 1002);
+    firstMenu->AppendItem("Quitter ", 1003);
 	
 	underMenu = new PIMenu((PIWdg *)firstMenu,(const char *)"submenu");
     firstMenu->AppendCascadeMenu(underMenu,1001);
-    printf ("Menus created \n");
+	underMenu->AppendItem("Sub 1 from 2",1010);
+	underMenu->AppendItem("Sub 2 from 2",1011);
+
+	figuresMenu = new PIMenu((PIWdg *)mainApp, (const char *)"Figures");
+	figuresMenu->AppendItem("Circle",2001);
+	figuresMenu->AppendItem("Polygone",2002);
+
+	printf ("Menus created \n");
     fflush (stdout);
-	underMenu->AppendItem("Sub from 2",2001);
-	printf ("SubMenus created \n");
-    fflush (stdout);
-
+	
     mBar = mainApp->Menubar();
     mBar->AppendMenu(firstMenu);
-    
-    windowFirst = new PIWindow((PIMsgHandler *)piCont, (const char *)"Window First",PIWK_normal,600,200,50,50);
-    wGen = new PIWindowGen((PIMsgHandler *)piCont,(const char *)"Window Gen",PIWK_normal,600,200,50,50);
-    piContQ = new PIContainer (piCont,(const char *)"Container First",600,200,50,50);
-    piWdg = new PIWdg (piCont,(const char *)"Wdg First",50,50,100,100);
+    mBar->AppendMenu(figuresMenu);
+	
+    windowFirst = new PIWindow((PIMsgHandler *)mainApp, (const char *)"Window First",PIWK_normal,600,200,50,50);
+	
 	piLabel = new PILabel(windowFirst,(const char *)"Label",80,40,150,50);
 
 	piButton = new PIButton(windowFirst, "Hello",777,60,20,80,80);
+	
+	optMenu = new PIOptMenu(windowFirst, "Opt Menu", 100,25,150,80);
+	popMenu = new PIMenu((PIWdg *)optMenu, (const char *)"Pop Menu",k_PopupMenu);
+	popMenu->AppendItem("pop 1",3001);
+	popMenu->AppendItem("pop 2",3002);
+	mBar->AppendPopupMenu(popMenu);
 
-    windowFirst->Refresh();
+	optMenu->AppendPDMenu(popMenu);
+	
 	piLabel->SetLabel("Etiquette");
 
+	windowFirst->Refresh();
+	fflush (stdout);
+	
+	pig = new PIGraphicWin (windowFirst);
+	// pig->SetClipRectangle(280,60,100,50);
+
+	PIGrCoord px(300);
+	PIGrCoord py(80);
+	PIGrCoord len(150);
+	PIGrCoord hei(50);
+	pig->SelForeground(PI_Blue);
+	pig->DrawFBox(px, py, len, hei);
+	pig->DrawString (px, py, "Graphic Text", 1);
+
+	PIGrCoord pxfin(450);
+	PIGrCoord pyfin(130);
+	pig->SelForeground(PI_Green);	
+	pig->DrawLine (px, py, pxfin, pyfin);
+
+	PIGrCoord deltax(60);
+	PIGrCoord deltay(30);
+	pig->SelForeground(PI_Red);	
+	pig->DrawArc (px, py, deltax, deltay, 0., 90.);
+
+	FillDatas();
+	
     mainApp->Run(); // Main loop
 
     return 0;
 }
+
+/* ============================== */
+void FillDatas()
+{
+	tabx = new PIGrCoord[NBCOTE];
+	taby = new PIGrCoord[NBCOTE];
+	
+	tabx[0] = 80 ;	tabx[1] = 100; tabx[2] = 120;	tabx[3] = 140;	tabx[4] = 130;	tabx[5] = 110; tabx[6] = 90;
+	taby[0] = 50;	taby[1] = 60; taby[2] = 70;	taby[3] = 80;	taby[4] = 60;	taby[5] = 40; taby[6] = 20;
+	return;
+}
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 3747)
@@ -0,0 +1,75 @@
+/*
+ *  pibwdgquartz.cpp
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 19/09/08.
+ *  Copyright 2008 __MyCompanyName__. All rights reserved.
+ *
+ */
+
+#include "pibwdgquartz.h"
+
+PIBaseWdgQuartz::PIBaseWdgQuartz(PIContainerGen *par, const char *nom,int sx, int sy, int px, int py)
+: PIBaseWdgGen(par,nom,sx,sy,px,py)
+{
+}
+
+PIBaseWdgQuartz::~PIBaseWdgQuartz()
+{
+}
+
+void PIBaseWdgQuartz::FinishCreate()
+{
+}
+
+void PIBaseWdgQuartz::ActivatePtrCross()
+{
+}
+ 
+void PIBaseWdgQuartz::ActivateButton(int bid)
+{
+}
+ 
+void PIBaseWdgQuartz::ActivateMove(int bid)
+{
+}
+ 
+void PIBaseWdgQuartz::ActivateKeyboard()
+{
+}
+ 
+void PIBaseWdgQuartz::SelPointerShape(PIPointer ptr)
+{
+}
+ 
+PIPointer PIBaseWdgQuartz::GetPointerShape()
+{
+}
+ 
+void PIBaseWdgQuartz::AssignKeyboard()
+{
+}
+
+// Acces aux caracteristiques du dernier evenement 
+void PIBaseWdgQuartz::GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm)
+{
+}
+
+// On redefinit IsVisible() pour tenir compte de l appel a FinsihCreate  
+bool PIBaseWdgQuartz::IsVisible()
+{
+	return true;
+}
+
+//  Fonction qui doit etre appelee pour rafraichir la fenetre 
+void PIBaseWdgQuartz::Refresh()
+{
+	return;
+}
+
+//  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
+void PIBaseWdgQuartz::eXposeProcess(int x0, int y0, int dx, int dy)
+{
+	return;
+}
+ 
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 3747)
@@ -0,0 +1,63 @@
+/*
+ *  pibwdgquartz.h
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on 19/09/08.
+ *
+ */
+
+#ifndef PIBWDGQUARTZ_H_SEEN
+#define PIBWDGQUARTZ_H_SEEN
+
+#include "pisysdep.h"
+#include "pibwdggen.h"
+
+#include "pigraphquartz.h"
+#include "pigraphps.h"
+
+class PIBaseWdgQuartz : public PIBaseWdgGen
+{
+
+public:
+// Les methodes ...
+
+                     PIBaseWdgQuartz(PIContainerGen *par, const char *nom,
+                                int sx=10, int sy=10, int px=0, int py=0);
+  virtual            ~PIBaseWdgQuartz();
+
+  virtual void       FinishCreate();   // appele par la fenetre mere, apres XtRealize()
+
+//  Activation des evenements   
+  virtual void       ActivatePtrCross();
+  virtual void       ActivateButton(int bid);
+  virtual void       ActivateMove(int bid);
+  virtual void       ActivateKeyboard();
+
+//  Divers : couleur de fond, Effacement fenetre,  forme de la souris
+  virtual void       SelPointerShape(PIPointer ptr=PI_ArrowPointer);
+  virtual PIPointer  GetPointerShape();
+  virtual void       AssignKeyboard();
+
+// Acces aux caracteristiques du dernier evenement 
+  virtual void       GetLastEventInfo(PIKeyModifier& kmod, unsigned long& tm);
+
+// On redefinit IsVisible() pour tenir compte de l appel a FinsihCreate  
+  virtual bool       IsVisible();
+
+//  Fonction qui doit etre appelee pour rafraichir la fenetre 
+  virtual void       Refresh();
+
+//  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
+  virtual void       eXposeProcess(int x0, int y0, int dx, int dy);
+ 
+protected:
+  void               Init();
+  PIPointer mPtrS;
+// pour s'assurer que le bon FinishCreate() est appele - pb lie aux tables de fonctions
+// virtuelles des classes qui sont remplies au fur et a mesure des constructeurs
+  bool               bwx_finishDone; 
+};
+
+typedef PIBaseWdgQuartz PIBaseWdg;
+
+#endif /* PIBWDGQUARTZ_H_SEEN */
Index: /trunk/SophyaPI/PI/Quartz/picmapquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/picmapquartz.cpp	(revision 3746)
+++ /trunk/SophyaPI/PI/Quartz/picmapquartz.cpp	(revision 3747)
@@ -2,5 +2,5 @@
 
 #include "sopnamsp.h"
-#include "piwdgmosx.h"
+#include "piwdgquartz.h"
 #include "picmapquartz.h"
 
